; Utilisation de la sortie d'un decodeur de tlcommande UM3750
; RA1 : Selection du mode
; RA2 : Selection de l'etat initial
; RA3 : Entre relie  la sortie du dcodeur
; RB1 : Sortie directe
; RB2 : Sortie supplmentaire (pre-sortie) du mode 2
; RB3 : sortie temporise 200ms
; RB4 : sortie tempo 400ms
; RB5 : sortie tempo 1s
; RB6 : sortie tempo 3s
; Le programme tant trs court, j'ai mis directement les bits du port concerns (i.e : bcf PORTB,1 pour mettre  1 la sortie)

; La sortie du UM3750 est  1 au repos, 0 lors d'une detection de signal

; Fait par Aurlien R. 02/2001
; Site : http://www.aurelienr.com
; E-mail : aurelienr@hotmail.com
;-------------------------------------------------------------------------------------------

	list p=16f84
	include <p16f84.inc>

; Config  programmer : XT=4MHz, TMR,WDT,CP=OFF

	cblock	0x0C		; declaration variables
		repet
		PDel0
		PDel1
		PDel2
		PDel3
	endc

	org	0
	goto	Start

	org	10		; Debut du programme
Start	clrf	PORTA
	clrf	PORTB
	movlw	B'11111111'		; tout le port A en entre
	tris	PORTA
	movlw	B'00000000'
	tris	PORTB		; tout le port B en sortie
	btfsc	PORTA,1		; contrle le bit de mode
	goto	Mode1		; si bitmode=1, alors mode 1
	goto	Mode2		; si bitmode=0, alors mode 2

;------------------------------------------------
	
Mode1	clrf	PORTB
	btfsc	PORTA,2		; contrle le bit d'etat
	bsf	PORTB,1		; met la sortie  1 si le bit d'etat est  1
Test1	btfsc	PORTA,3		; contrle la sortie du UM3750
	goto	Test1		; si rien (=bit  1), continue  tester
	comf	PORTB,1		; inverse l'etat du port B
	movlw	B'00000010'
	andwf	PORTB,1		; on remet tout RB  0 sauf RB1
	bsf	PORTB,6		; on met  1 toutes les sorties temporises
	bsf	PORTB,5
	bsf	PORTB,4
	bsf	PORTB,3
	call	Tempo200ms
	bcf	PORTB,3		; on remet  0 RB3 au bout de 200ms
	call	Tempo200ms
	bcf	PORTB,4		; RB4  0 au bout d'un total de 400ms
	call	Tempo200ms
	call	Tempo200ms
	call	Tempo200ms
	bcf	PORTB,5		; RB5  0 au bout d'une seconde
	clrf	repet
	movlw	D'10'
	movwf	repet
Tempo2s	call	Tempo200ms		; temporisation de 2 secondes
	decfsz	repet,1
	goto	Tempo2s
	bcf	PORTB,6		; on remet  0 RB6
	goto	Test1		; on est prt  recevoir un nouvel ordre de la telecommande
	
;------------------------------------------------

Mode2	clrf	PORTB
	btfsc	PORTA,2		; teste le bit d'etat initial
	bsf	PORTB,1		; si il est  1, on met la sortie  1
Test2	bcf	PORTB,2
	btfsc	PORTA,3		; teste sortie du UM3750
	goto	Test2		; si sortie  1 (normal), on re-teste
	bsf	PORTB,2		; si reois un signal (etat 0), met  1 la sortie 2 (pre-sortie)
	call	Tempo200ms		; 200ms d'ecart
	clrf	repet
	movlw	D'200'
	movwf	repet
Test3	call	Tempo5ms		; la pression sur une touche de tlec. dpasse en gnral 5ms !
	decfsz	repet,1
	goto	Verif
	goto	Test2		; si rien n'a t dtect pendant la seconde de test, on revient au depart
Verif	btfsc	PORTA,3		; test de la sortie du dcodeur
	goto	Test3	
	bcf	PORTB,2
	comf	PORTB,1		; inverse l'etat du port B si impulsion dtecte
	movlw	B'00000010'
	andwf	PORTB,1		; on remet tout RB  0 sauf RB1 qui garde son changement
	bsf	PORTB,3
	bsf	PORTB,4
	bsf	PORTB,5
	bsf	PORTB,6
	call	Tempo200ms
	bcf	PORTB,3
	call	Tempo200ms
	bcf	PORTB,4
	call	Tempo200ms
	call	Tempo200ms
	call	Tempo200ms
	bcf	PORTB,5
	clrf	repet
	movlw	D'10'
	movwf	repet
Tempob2s	call	Tempo200ms		; temporisation de 2 secondes : telecommande inutilisable
	decfsz	repet,1
	goto	Tempob2s
	bcf	PORTB,6
	goto	Test2		

;------------------------------------------------
; Parties de programme faite par PICDEL (gnrateur de temporisations pour PIC)

; Temporisation 200ms
Tempo200ms	movlw	D'156'		; 1 set number of repetitions (B)
	movwf	PDel0		; 1 |
PLoop1	movlw	D'213'		; 1 set number of repetitions (A)
	movwf	PDel1		; 1 |
PLoop2	clrwdt			; 1 clear watchdog
PDelL1	goto PDelL2			; 2 cycles delay
PDelL2  
	decfsz	PDel1,1		; 1 + (1) is the time over? (A)
	goto	PLoop2		; 2 no, loop
	decfsz	PDel0,1		; 1 + (1) is the time over? (B)
	goto	PLoop1		; 2 no, loop
PDelL3	goto	PDelL4		; 2 cycles delay
PDelL4	clrwdt			; 1 cycle delay
	return    

; Temporisation 5ms
Tempo5ms	movlw	.6		; 1 set number of repetitions (B)
	movwf	PDel2		; 1 |
PLoop3	movlw	.207		; 1 set number of repetitions (A)
	movwf	PDel3		; 1 |
PLoop4	clrwdt			; 1 clear watchdog
	decfsz	PDel3, 1		; 1 + (1) is the time over? (A)
	goto	PLoop4		; 2 no, loop
	decfsz	PDel2,  1		; 1 + (1) is the time over? (B)
	goto	PLoop3		; 2 no, loop
PDelL5	goto	PDelL6		; 2 cycles delay
PDelL6	clrwdt			; 1 cycle delay
	return			; 2+2 Done

	End
